VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsParametre"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private strAdr As String
Private strNom As String
Private strTipus As String
Private strLongitud As String
Private strRW As String
Private lngMaximValor As Long
Private dblValor As Double
Private dblValorUltim As Double
Private bolValid As Boolean
Private colVariables As Collection
Private colBits As Collection

Public Function Inicialitza(strCadena As String) As Boolean
Dim varP As Variant

   On Error GoTo TractaError
   
   'Creo la coleccio de variables (nomes em serveix pels parametres tipus TRAMA)
   Set colVariables = New Collection
   'Creo la coleccio de conjunts de bits (nomes em serveix pels parametres tipus BITS)
   Set colBits = New Collection
   'Miro si tinc alguna coma a la cadena que em passen
   If InStr(1, strCadena, ",") > 1 Then
      'Passo la cadena a una matriu
      varP = Split(strCadena, ",")
      'Miro si la matriu es valida
      If UBound(varP) = 6 Then
         'Capturo les dades del parametre
         strAdr = varP(0)              'Adr = Adrea de la variable del PLC
         strNom = varP(1)              'Nom = nom de la variable per pantalla
         strTipus = UCase(varP(2))     'BITS | WORD | TRAMAxx
         strLongitud = UCase(varP(3))  'Longitud = numero de variables que vull llegir/escriure de cop
         strRW = UCase(varP(4))        'R = Read, W = Write, RW = Read/Write
         lngMaximValor = Val(varP(5))  'Maxim valor permes, si es 0 vol dir que no te limit maxim
         dblValor = CDbl(varP(6))      'Valor = ultim valor enviat al PLC
         'Miro si el parametre es d'escriptura
         If strRW = "W" Or strRW = "RW" Then
            'Indico que el valor del parametre s'ha de validar abans d'enviar
            bolValid = False
         Else
            'Els parametres de lectura no s'han de validar
            bolValid = True
         End If
         'Valido el tipus [BITS|WORD|TRAMAxx] i els permisos [R|W|RW]
         If (strTipus = "WORD" Or Left(strTipus, 4) = "BITS" Or Left(strTipus, 5) = "TRAMA") And (strRW = "R" Or strRW = "W" Or strRW = "RW") Then
            'Selecciono en funcio del tipus de variable
            Select Case Left(strTipus, 1)
               'Miro si es tracta d'una trama de variables
               Case "T"
                  'Carrego les variables de la trama
                  If CarregarVariablesTrama() Then
                     'Retorno true
                     Inicialitza = True
                  End If
               'Miro si es tracta d'una variable que funciona a nivell de bits
               Case "B"
                  'Carrego els bits de la variable Config
                  If CarregarBitsConfig() Then
                     'Retorno true
                     Inicialitza = True
                  End If
               'Miro si es tracta d'una variable Word
               Case "W"
                  'Retorno true
                  Inicialitza = True
               'Si no conec el tipus de variable
               Case Else
                  'Retorno true
                  Inicialitza = False
            End Select
         End If
      End If
   End If
         
Exit Function
TractaError:
   Inicialitza = False
End Function

Public Property Get Adresa() As String
   'Retorno l'adrea de la variable
   Adresa = strAdr
End Property

Public Property Get Nom() As String
   'Retorno el nom del parametre
   Nom = strNom
End Property

Public Property Get Tipus() As String
   'Retorno el tipus del parametre
   Tipus = strTipus
End Property

Public Property Get Longitud() As Long
   'Retorno el numero de variables que vull llegir/escriure de cop
   Longitud = Val(strLongitud)
End Property

Public Property Get ModeWrite() As Boolean
   'Retorno true si te permis d'escriptura: W o RW
   If strRW = "W" Or strRW = "RW" Then
      ModeWrite = True
   End If
End Property

Public Property Get ModeRead() As Boolean
   'Retorno true si te permis de lectura: R o RW
   If strRW = "R" Or strRW = "RW" Then
      ModeRead = True
   End If
End Property

Public Property Get MaximValor() As Long
   'Retorno el limit maxim del valor
   MaximValor = lngMaximValor
End Property

Public Property Get Valid() As Boolean
   'Retorno el flag
   Valid = bolValid
End Property

Public Property Let Valid(v As Boolean)
   'Assigno el flag
   bolValid = v
End Property

Public Property Get Valor() As Double
   'Retorno el valor del parametre
   Valor = dblValor
End Property

Public Property Let ValorWord(v As Double)

   On Error GoTo TractaError
   'Assigno el valor del parametre
   dblValor = CDbl(Int(v))
   
Exit Property
TractaError:
   dblValor = -1
End Property
Public Property Let Valor(v As Double)

   On Error GoTo TractaError
   'Assigno el valor del parametre
   dblValor = CDbl(Int(v))
   
Exit Property
TractaError:
   dblValor = -1
End Property

Public Function ValorsTrama(strValors As String, strDelimitador As String) As Boolean
Dim ix As Integer
Dim bolError As Boolean

   On Error GoTo TractaError
   'Bucle per totes les variables de la trama
   For ix = 1 To colVariables.Count
      'Actualitzo el valor de cada variable individual
      If Not colVariables(ix).SetValor(strValors, strDelimitador) Then
         'Activo el flag per indicar error
         bolError = True
      End If
   Next ix
   'Retorno true si no hi ha error, false en cas contrari
   ValorsTrama = Not bolError
   
Exit Function
TractaError:
   ValorsTrama = False
End Function

Public Function ValorsBits(strValor As String) As Boolean
Dim ix As Integer
Dim bolError As Boolean
         
   On Error GoTo TractaError
   'Bucle per tots els bits
   For ix = 1 To colBits.Count
      'Actualitzo el valor de cada bit individual
      If Not colBits(ix).SetValor(strValor) Then
         'Activo el flag per indicar error
         bolError = True
      End If
   Next ix
   'Retorno true si no hi ha error, false en cas contrari
   ValorsBits = Not bolError
   
Exit Function
TractaError:
   ValorsBits = False
End Function

Public Function GetParametre() As String
   'Retorno tota la cadena que descriu el parametre, per guardar-lo en el fitxer de configuracio
   GetParametre = strAdr & "," & strNom & "," & strTipus & "," & strRW & "," & lngMaximValor & "," & dblValor
End Function

Public Function EsUnaTrama() As Boolean
   'Retorno true si el parametre es una trama de variables
   If colVariables.Count > 0 Then
      EsUnaTrama = True
   End If
End Function

Public Function EsUnConjuntDeBits() As Boolean
   'Retorno true si el parametre es un conjunt de bits
   If Left(strTipus, 4) = "BITS" Then
      EsUnConjuntDeBits = True
   End If
End Function

Public Function Variables() As Collection
   'Retorno tota la coleccio de variables
   Set Variables = colVariables
End Function

Private Function CarregarVariablesTrama() As Boolean
Dim intID As Integer
Dim strID As String
Dim strCadena As String
Dim objVariable As clsVariable

   On Error GoTo TractaError
   'Bucle per totes les variables possibles
   For intID = 1 To 999
      'Llegeixo la variable del fitxer de configuracio, a l'apartat indicat pel tipus (TRAMAxx)
      strID = Format(intID, "000")
      strCadena = INI_Get("V" & strID, "", strTipus, strFitxerConfig)
      'Si he llegit una cadena valida
      If strCadena <> "" Then
         'Creo un nou objecte variable
         Set objVariable = New clsVariable
         'Si es valida
         If objVariable.Inicialitza(strTipus, "V" & strID, strCadena) Then
            'Afegeixo la variable a la coleccio
            colVariables.Add objVariable, objVariable.Nom
            'Retorno true
            CarregarVariablesTrama = True
         Else
            'Retorno false
            CarregarVariablesTrama = False
            Exit For
         End If
      End If
   Next intID
   
Exit Function
TractaError:
   CarregarVariablesTrama = False
End Function

Public Function Bits() As Collection
   'Retorno tota la coleccio de bits
   Set Bits = colBits
End Function

Private Function CarregarBitsConfig() As Boolean
Dim intID As Integer
Dim strID As String
Dim strCadena As String
Dim objBit As clsBit

   On Error GoTo TractaError
   'Bucle per totes les variables possibles
   For intID = 1 To 16
      'Llegeixo la variable del fitxer de configuracio, a l'apartat indicat pel tipus (BITS)
      strID = Format(intID, "00")
      strCadena = INI_Get("B" & strID, "", strTipus, strFitxerConfig)
      'Si he llegit una cadena valida
      If strCadena <> "" Then
         'Creo un nou objecte bit
         Set objBit = New clsBit
         'Inicialitzo l'objecte bit
         If objBit.Inicialitza(strCadena) Then
            'Afegeixo el nou bit a la coleccio
            colBits.Add objBit, objBit.Nom
            'Retorno true
            CarregarBitsConfig = True
         Else
            'Retorno false
            CarregarBitsConfig = False
            Exit For
         End If
      End If
   Next intID
   
Exit Function
TractaError:
   CarregarBitsConfig = False
End Function

