VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsVariable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event Actualitza()

Private strTramaID As String
Private strID As String
Private strAdr As String
Private strNom As String
Private strTipus As String
Private intPosicio As Integer
Private dblValor As Double
Private dblFactorConversio As Double
Private bolConfigurarPLC As Boolean

Public Function Inicialitza(strIdentTrama As String, strIdent As String, strCadena As String) As Boolean
Dim varP As Variant

   On Error GoTo TractaError
   
   'Em guardo l'identificador de la trama
   strTramaID = strIdentTrama
   'Em guardo l'identificador de la variable
   strID = strIdent
   'Miro si tinc alguna coma a la cadena que em passen
   If InStr(1, strCadena, ",") > 1 Then
      'Passo la cadena a una matriu
      varP = Split(strCadena, ",")
      'Miro si la matriu es valida
      If UBound(varP) = 6 Then
         'Capturo les dades del parametre
         strAdr = varP(0)              'Adr = Adrea de la variable del PLC
         strNom = varP(1)              'Nom = nom de la variable per pantalla
         strTipus = UCase(varP(2))     'WORD = word simple, DWORD = word doble
         intPosicio = CInt(varP(3))    'Posicio = posicio de la variable dintre la trama
         dblFactorConversio = ConvertirADecimal(CStr(varP(4)))   'dblFactorConversio = factor de conversio per mostrar la variable per pantalla
         dblValor = (Val(varP(5)))     'Ultim valor = ultim valor de la variable
         bolConfigurarPLC = IIf(varP(6) = "SI", True, False)   'Configurar_PLC = SI indica que es una variable que s'ha d'enviar al PLC quan inicio Scada
         'Valido el tipus [WORD|DWORD]
         If (strTipus = "WORD" Or strTipus = "DWORD") Then
            'Retorno true
            Inicialitza = True
         End If
      End If
   End If
         
Exit Function
TractaError:
   Inicialitza = False
End Function

Public Property Get Adresa() As String
   'Retorno l'adrea de la variable
   Adresa = strAdr
End Property

Public Property Get Nom() As String
   'Retorno el nom del parametre
   Nom = strNom
End Property

Public Property Get Tipus() As String
   'Retorno el tipus del parametre
   Tipus = strTipus
End Property

Public Property Get Posicio() As Integer
   'Retorno la posicio de la variable dintre de la trama
   Posicio = intPosicio
End Property

Public Property Get Valor() As Double
   'Retorno el valor del parametre, corregit amb el factor de conversio [1, 0.1, 0.01, 0.001, ...]
   Valor = dblValor * dblFactorConversio
End Property

Public Function SetValor(strValors As String, strDelimitador As String) As Boolean
Dim varValors As Variant
Dim strValorL As String
Dim strValorH As String
Dim dblValorL As Double
Dim dblValorH As Double

   On Error GoTo TractaError
   'Si els valors que em passen son valids
   If strValors <> "" Then
      'Passo la cadena a una matriu
      varValors = Split(strValors, strDelimitador)
      'Comprovo que la posicio sigui valida en referencia al total de valors
      If UBound(varValors) >= intPosicio Then
         'Selecciono en funcio del tipus
         Select Case strTipus
            
            'WORD
            Case "WORD"
               'Capturo el valor LOW de la variable en funcio de la posicio
               strValorL = varValors(intPosicio)
               'Miro si ha canviat el valor
               If dblValor <> CDbl(strValorL) Then
                  'Passo el valor a un double
                  dblValor = CDbl(strValorL)
                  'Guardo la variable al fitxer ini
                  GuardarVariable -1
               End If
               'Retorno true
               SetValor = True
            
            'DWORD, o sigui una Double Word
            Case "DWORD"
               'Capturo el valor LOW de la variable en funcio de la posicio
               strValorL = varValors(intPosicio)
               'Passo el valor a un double
               dblValorL = CDbl(strValorL)
               'Capturo el valor HIGH de la variable en funcio de la posicio
               strValorH = varValors(intPosicio + 1)
               'Passo el valor a un double i multiplico per 2^16
               dblValorH = CDbl(strValorH) * 65536
               'Miro si ha canviat el valor
               If dblValor <> dblValorL + dblValorH Then
                  'Em guardo el valor total
                  dblValor = dblValorL + dblValorH
                  'Guardo la variable al fitxer ini
                  GuardarVariable -1
               End If
               'Retorno true
               SetValor = True
      
            Case Else
               'Retorno false
               SetValor = False
         
         End Select
      
      End If
   End If
   'Activo l'event per actualitzar els elements relacionats amb la variable
   RaiseEvent Actualitza
   
Exit Function
TractaError:
   SetValor = False
End Function

Private Function ConvertirADecimal(strNumero As String) As Double
Dim p As Integer
Dim strN1 As String
Dim strN2 As String

   On Error GoTo TractaError
   'Busco la posicio del punt
   p = InStr(1, strNumero, ".")
   If p > 0 Then
      'Capturo la part entera del numero
      strN1 = Left(strNumero, p - 1)
      'Capturo la part decimal del numero
      strN2 = Mid(strNumero, p + 1)
      'Converteixo a decimal
      ConvertirADecimal = CDbl(strN1 & "," & strN2)
   Else
      'Retorno 1
      ConvertirADecimal = 1
   End If
   
Exit Function
TractaError:
   'Retorno 1
   ConvertirADecimal = 1
End Function

Public Sub GuardarVariable(lngValor As Long)
Dim strCadena As String

   On Error Resume Next
   'Miro que no sigui una variable de configuracio del PLC, o em forcen un valor
   If Not bolConfigurarPLC Or lngValor > -1 Then
      'Miro si em forcen un valor
      If lngValor > -1 Then
         'Genero la cadena que descriu l'estat actual de la variable per guardar-la al fitxer ini
         strCadena = strAdr & "," & strNom & "," & strTipus & "," & intPosicio & "," & dblFactorConversio & "," & lngValor & "," & IIf(bolConfigurarPLC, "SI", "NO")
      Else
         'Genero la cadena que descriu l'estat actual de la variable per guardar-la al fitxer ini
         strCadena = strAdr & "," & strNom & "," & strTipus & "," & intPosicio & "," & dblFactorConversio & "," & CLng(dblValor) & "," & IIf(bolConfigurarPLC, "SI", "NO")
      End If
      'Guardo la variable en el fitxer ini
      INI_Put strID, strCadena, strTramaID, strFitxerConfig
   End If
   
End Sub

Public Property Get ConfigurarPLC() As Boolean
   'Retorno true o false
   ConfigurarPLC = bolConfigurarPLC
End Property
