Attribute VB_Name = "modSISTEMA"
Option Explicit

'-- Declaro les variables globals
Public strFitxerRegistre As String
Public strFitxerConfig As String
Public strDelimitador As String

'-- Declaro les constants
Public Const CTE_FITXER_REGISTRE = "Registre.log"
Public Const CTE_PROJECTE = "SVAOmronTamarite"
Public Const CTE_SEPARADOR = " "
'Defineixo els possibles estats dels bits
Public Const BIT_ON = 1
Public Const BIT_OFF = 0

Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMiliseconds As Long)

'-----------------------------------------------------------------
'-- Main()
'-----------------------------------------------------------------
' Rutina principal d'inicialitzacio del programa
'-----------------------------------------------------------------
Public Sub Main()

   On Error GoTo TractaError

   '-- Si hi ha una altra instancia de l'aplicacio en funcionament, surto
   If App.PrevInstance Then
      End
   End If
   '-- Carrega les configuracions
   If Configura() Then
      '-- Mostro el formulari frmPrincipal
      frmPrincipal.Show vbModal
   Else
      '-- Surto del programa
      End
   End If
   
Exit Sub
TractaError:
   RegistraError "Main() - Error: " & Err.Number & ", " & Err.Description, True
   End
End Sub

'----------------------------------------------------
'-- RegistraError()
'----------------------------------------------------
' Rutina per registrar l'error en el log i per mostrar
' el missatge per pantalla, en funcio del flag que em passen
'----------------------------------------------------
Public Sub RegistraError(strMissatge As String, bolMostrar As Boolean)
Dim f As Integer

   On Error GoTo TractaError
   
   If Len(strMissatge) > 0 Then
      '-- Obro el fitxer de registre
      f = FreeFile
      Open strFitxerRegistre For Append As #f
      '-- Guardo l'error en el log
      Print #f, Format(Now, "dd/mm/yyyy hh:mm:ss") & " - " & CTE_PROJECTE & ": " & strMissatge
      Close #f
      If bolMostrar Then
         '-- Mostro el missatge per pantalla
         frmPrincipal.MostrarMissatge Format(Now, "dd/mm/yyyy _ hh:mm:ss") & " - " & CTE_PROJECTE & ": " & strMissatge
      End If
   End If

Exit Sub
TractaError:
   If bolMostrar Then
      frmPrincipal.MostrarMissatge CTE_PROJECTE & ": RegistraError() - Error: " & Err.Number & ", " & Err.Description
   End If
End Sub

'----------------------------------------------------
'-- Configura()
'----------------------------------------------------
' Rutina per llegir les configuracions del fitxer ini
'----------------------------------------------------
Public Function Configura() As Boolean

   On Error GoTo TractaError
   
   '-- Nom del fitxer de configuracio
   strFitxerConfig = App.Path & "\" & App.EXEName & ".ini"
   '-- Nom del fitxer de registre
   strFitxerRegistre = App.Path & "\" & CTE_FITXER_REGISTRE
   '-- Si existeix el fitxer de configuracio
   If Dir(strFitxerConfig) <> "" Then
      '-- Retorno True
      Configura = True
   Else
      RegistraError "NO SE HA ENCONTRADO EL FICHERO DE CONFIGURACIN", True
   End If
   
Exit Function
TractaError:
   RegistraError "Configura() - Error: " & Err.Number & ", " & Err.Description, True
End Function

'----------------------------------------------------
'-- LlegirFitxer()
'----------------------------------------------------
' Rutina per llegir TOT el contingut d'un fitxer
'----------------------------------------------------
Public Function LlegirFitxer(strNomFitxer As String) As String
Dim f As Long
Dim buf() As Byte

   On Error GoTo TractaError
   
   '-- Obro el fitxer
   f = FreeFile
   Open strNomFitxer For Binary Access Read As #f
   If LOF(f) > 0 Then
      '-- Redimensiono la matriu de bytes
      ReDim buf(1 To LOF(f)) As Byte
      '-- Llegeixo els bytes del fitxer
      Get #f, , buf
      '-- Tanco el fitxer
      Close #f
      '-- Retorno el fitxer
      LlegirFitxer = StrConv(buf, vbUnicode)
   End If
   DoEvents
   
Exit Function
TractaError:
   RegistraError "LlegirFitxer() - Error: " & Err.Number & ", " & Err.Description, True
End Function

Public Sub Espera(lngMilis As Long)
   Sleep lngMilis
End Sub


